module BlackStack

  module BaseProxy
    
    # 
    def chrome_switches
      return ["--proxy-server=#{self.ip}:#{self.port}","--proxy-user-and-password=#{self.user}:#{self.password}"]      
    end
  
    # Warning: Out to Date
    def firefox_profile_parameter(agent_name = nil, profile_name = nil)
      if (profile_name == nil)
        profile = Selenium::WebDriver::Firefox::Profile.new
      else
        profile = Selenium::WebDriver::Firefox::Profile.from_name profile_name
      end
      
      if (agent_name!=nil)
        profile['general.useragent.override'] = agent_name
      end
  
      proxy = Selenium::WebDriver::Proxy.new(:http => self.ip.to_s+":"+self.port.to_s, :ssl => self.ip.to_s+":"+self.port.to_s)
      profile.proxy = proxy
      return profile
    end
  
    # Warning: Out to Date
    def phantomjs_switches
      return ['--proxy='+self.ip.to_s+':'+self.port.to_s, '--proxy-auth='+self.user.to_s+':'+self.password.to_s, '--ignore-ssl-errors=yes', '--ssl-protocol=any', '--load-images=false']
    end  
  end

end # module BlackStack
